# snapshotver is year-month-day-svnrevision, generated by "make dist"
%define snapshot        0
%define snapshotversion 20140212svn5159
%define rel             3

Summary:	Viewer for the VNC remote display system
Name:		tigervnc
Version:	1.3.1
%if %{snapshot}
Release:	0.%{snapshotversion}.%{rel}
Source0:	%{name}-%{version}-%{snapshotversion}.tar.bz2
%else
Release:	%{rel}
Source0:	http://optimate.dl.sourceforge.net/project/tigervnc/tigervnc/%{version}/%{name}-%{version}.tar.gz
%endif
License:	GPLv2+
Group:		Networking/Remote access
Url:		http://www.tigervnc.com/
Source1:	vncviewer.desktop
# Missing from "make dist":
Source2:	%{name}-media.tar.gz
Source3:	vncserver.service
Source4:	vncserver.sysconfig
Source5:	10-libvnc.conf
# we put cmake build into a different dir
Patch1:		tigervnc-1.2.80-builddir.patch
Patch3:		tigervnc-1.2.80-strfmt.patch
# fedora patches
Patch10:	tigervnc-cookie.patch
Patch11:	tigervnc11-ldnow.patch
Patch12:	tigervnc11-gethomedir.patch
Patch13:	tigervnc11-rh692048.patch
Patch15:	tigervnc-setcursor-crash.patch
Patch16:	tigervnc-manpages.patch
Patch17:	tigervnc-getmaster.patch
Patch18:	tigervnc-shebang.patch
Patch19:	tigervnc-1.3.0-xserver-1.15.patch
Patch21:	tigervnc-zrle-crash.patch
Patch22:	tigervnc-cursor.patch

#(proyvind): FIXME: this one got fscked, needs to be fixed in Makefile.am, so
# that miext/sync/libsync.la gets built first...
#Patch18: tigervnc-1.0.90-link-against-forgotten-local-library.patch

BuildRequires:	cmake
BuildRequires:	imagemagick
BuildRequires:	nasm
BuildRequires:	x11-font-util
BuildRequires:	x11-server-source
BuildRequires:	x11-util-macros
BuildRequires:	fltk-devel
BuildRequires:	gettext-devel
BuildRequires:	java-1.7.0-openjdk-devel
BuildRequires:	pam-devel
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(gnutls)
BuildRequires:	pkgconfig(libtirpc)
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pkgconfig(pciaccess)
BuildRequires:	pkgconfig(pixman-1)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xext)
BuildRequires:	pkgconfig(xfont)
BuildRequires:	pkgconfig(xi)
BuildRequires:	pkgconfig(xkbfile)
BuildRequires:	pkgconfig(xtrans)
BuildRequires:	pkgconfig(xtst)

# Old RealVNC package:
Provides:	vncviewer
Conflicts:	tightvnc

%description
Virtual Network Computing (VNC) is a remote display system which
allows you to view a computing 'desktop' environment not only on the
machine where it is running, but from anywhere on the Internet and
from a wide variety of machine architectures.  This package contains a
client which will allow you to connect to other desktops running a VNC
server.

%files -f %{name}.lang
%doc README.txt
%{_bindir}/vncviewer
%{_iconsdir}/*
%{_datadir}/applications/*
%{_mandir}/man1/vncviewer.1*

#------------------------------------------------------------------------------

%package server
Summary:	Server for the VNC remote display system
Group:		Networking/Remote access
# Old RealVNC package:
Provides:	vnc-server
Conflicts:	tightvnc-server
# no longer require it because we have systemd service now
#Requires:	vnc-server-common
Conflicts:	vnc-server-common

%description server
The VNC system allows you to access the same desktop from a wide
variety of platforms.  This package is a TigerVNC server, allowing
others to access the desktop on your machine.

%files server
%{_bindir}/vncconfig
%{_bindir}/vncpasswd
%{_bindir}/x0vncserver
%{_bindir}/Xvnc
%{_bindir}/vncserver
%{_mandir}/man1/Xvnc.1*
%{_mandir}/man1/vncpasswd.1*
%{_mandir}/man1/vncconfig.1*
%{_mandir}/man1/vncserver.1*
%{_mandir}/man1/x0vncserver.1*
%config(noreplace) %{_sysconfdir}/sysconfig/vncservers
%{_unitdir}/vncserver@.service

#------------------------------------------------------------------------------

%package server-module
Summary:	Xorg module for the VNC remote display system
Group:		Networking/Remote access
Provides:	vnc-server-module
Requires:	x11-server-xorg

%description server-module
This package contains libvnc.so module to X server, allowing others
to access the desktop on your machine.

%files server-module
%{_libdir}/xorg/modules/extensions/libvnc.so
%config %{_sysconfdir}/X11/xorg.conf.d/10-libvnc.conf

#------------------------------------------------------------------------------

%package java
Summary:	Java viewer for the VNC remote display system
Group:		Networking/Remote access
# Old RealVNC package:
Provides:	vnc-java
Conflicts:	tightvnc-java

# "TightVNC-specific" is not a typo, see the README file located inside the
# java source tree
%description java
This distribution is based on the standard VNC source and includes new
TightVNC-specific features and fixes, such as additional low-bandwidth
optimizations, major GUI improvements, and more.

There are three basic ways to use TigerVNC Java viewer:
  1. Running applet as part of TigerVNC server installation.
  2. Running applet hosted on a standalone Web server.
  3. Running the viewer as a standalone application.

%files java
%{_javadir}/*.jar
%{_datadir}/%{name}

#------------------------------------------------------------------------------

%prep
%if %{snapshot}
%setup -q -n %{name}-%{version}-%{snapshotversion} -a2
%else
%setup -q -a2
%endif
cp -r /usr/share/x11-server-source/* unix/xserver
pushd unix/xserver
for all in `find . -type f -perm -001`; do
	chmod -x "$all"
done
patch -p1 -b --suffix .vnc < ../xserver114.patch
popd
%apply_patches

%build
# Temporary build with -fno-omit-frame-pointer, it causes problems
export CFLAGS="%{optflags} -fno-omit-frame-pointer"
export CXXFLAGS="$CFLAGS"

%cmake
%make
cd ..

# XXX: I'm not sure this define is actually needed
# Need this for shared objects that reference X Server, or other modules symbols
# Search for modules in extra_module_dir before the default path.
# This will allow fglrx to install its modified modules in more cleaner way.
%define extra_module_dir %{_libdir}/xorg/extra-modules

pushd unix/xserver
rm -f configure
autoreconf -fiv

# After the "--disable-config-hal", most options are just a paste from
# Mandriva's x11-server. We need to check what we can clean here (without
# reducing features)
%configure2_5x  --disable-xorg \
		--disable-xwin \
		--disable-xvfb \
		--disable-xnest \
		--disable-dmx \
		--disable-xfbdev \
		--disable-xephyr \
		--disable-kdrive \
		--disable-config-dbus \
		--enable-glx --disable-dri --enable-dri2 \
		--disable-config-hal \
		--disable-present \
		--disable-selective-werror \
		--disable-static \
		--disable-unit-tests \
		--with-log-dir=%{_logdir} \
		--with-os-vendor="%{vendor}" \
		--with-os-name="`echo \`uname -s -r\` | sed -e s'/ /_/g'`" \
		--with-vendor-web="%{disturl}" \
		--with-extra-module-dir=%{extra_module_dir} \
		--enable-xwrapper \
		--enable-pam \
		--with-default-font-path="catalogue:%{_sysconfdir}/X11/fontpath.d"

%make
popd

# Build icons
pushd media
%make
popd

# Build java
pushd java
%cmake
%make
popd

%install
pushd build
%makeinstall_std
popd

pushd unix/xserver/hw/vnc
%makeinstall_std
popd

# Install systemd unit file
mkdir -p %{buildroot}%{_unitdir}
install -m644 %{SOURCE3} %{buildroot}%{_unitdir}/vncserver@.service
rm -rf %{buildroot}%{_initrddir}

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
install -m644 %{SOURCE4} %{buildroot}%{_sysconfdir}/sysconfig/vncservers

# Install desktop stuff
mkdir -p %{buildroot}/%{_datadir}/icons/hicolor/{16x16,24x24,48x48}/apps

pushd media/icons
    for s in 16 24 48; do
	install -m644 tigervnc_$s.png %{buildroot}/%{_datadir}/icons/hicolor/${s}x$s/apps/tigervnc.png
    done
popd

mkdir %{buildroot}/%{_datadir}/applications
desktop-file-install \
	--dir %{buildroot}%{_datadir}/applications \
	%{SOURCE1}

%find_lang %{name}

mkdir -p %{buildroot}%{_sysconfdir}/X11/xorg.conf.d/
install -c -m 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/X11/xorg.conf.d/10-libvnc.conf

# remove unwanted files
rm -f  %{buildroot}/%{_libdir}/xorg/modules/extensions/libvnc.la
rm -rf  %{buildroot}/%{_datadir}/doc/%{name}-%{version}

# java
install -d -m 755 %{buildroot}%{_javadir}
install -d -m 755 %{buildroot}%{_datadir}/%{name}/classes
pushd java/build
    install -m 755 VncViewer.jar %{buildroot}%{_datadir}/%{name}/classes/vncviewer-%{version}.jar
popd

pushd java
    install -m 644 com/tigervnc/vncviewer/index.vnc %{buildroot}%{_datadir}/%{name}/classes
popd

pushd %{buildroot}%{_datadir}/%{name}/classes
    mv vncviewer-%{version}.jar %{buildroot}%{_javadir}
    ln -s %{_javadir}/vncviewer-%{version}.jar VncViewer.jar
popd

pushd %{buildroot}%{_javadir}
    ln -s vncviewer-%{version}.jar vncviewer.jar
    ln -s vncviewer-%{version}.jar VncViewer.jar
popd


%changelog
* Wed Sep 10 2014 Arkady Shane <ashejn@gmail.com> 1.3.1-3
+ Revision: 8046147
- bump release to rebuilt against new fltk


